<template>
  <v-container>
    <v-row justify="center">
      <v-dialog
          v-model="dialogPost"
          fullscreen
          hide-overlay
          transition="dialog-bottom-transition"
          :retain-focus="false"
      >
        <template v-slot:activator="{ on, attrs }">
          <v-btn
              color="primary"
              dark
              v-bind="attrs"
              v-on="on"
          >
            Créer une Facture
          </v-btn>
        </template>
        <v-card>
          <v-toolbar
              dark
              color="primary"
          >
            <v-btn
                icon
                dark
                @click="dialogPost = false"
            >
              <v-icon>mdi-close</v-icon>
            </v-btn>
            <v-toolbar-title>Formulaire ajout Facture</v-toolbar-title>
            <v-spacer></v-spacer>
          </v-toolbar>
          <div>
            <v-card>
              <v-card-title>
                <span class="headline">Facture</span>
              </v-card-title>
              <v-card-text>
                <v-container>
                  <v-form>
                    <v-row>
                        <v-col cols="12">
                            <v-text-field
                                v-model="price"
                                label="Prix*"
                                type="text"
                                required
                            ></v-text-field>
                        </v-col>
                        <v-col cols="12">
                            <v-text-field
                                v-model="pay_date"
                                label="date de payement*"
                                type="date"
                                required
                            ></v-text-field>
                        </v-col>
                    </v-row>
                  </v-form>
                </v-container>
                <small>*L'étoile indique les champs requis</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn
                    color="blue darken-1"
                    text
                    @click="dialogPost = false"
                >
                  Fermer la fenêtre
                </v-btn>
                <v-btn
                    color="blue darken-1"
                    @click="dialogPost = false; postFacture();"
                >
                  Créer
                </v-btn>
              </v-card-actions>
            </v-card>
          </div>
        </v-card>
      </v-dialog>
    </v-row>
    <v-list>
      <v-list-item
          v-for="facture in factures"
          :key="facture.id"
      >
        <facture-component
            :id="facture.id"
            :price="facture.price"
            :pay_date="facture.pay_date"
            :date_created="facture.date_created"
            @updated="getFactures"
        />
      </v-list-item>
    </v-list>
  </v-container>
</template>

<script>
import FactureComponent from "../components/FactureComponent";

export default {
  price: "Facture",
  components: {FactureComponent},
  data(){
    return {
      dialogPost: false,
      dialogPatch: false,
      factures: [],
      price: '',
      pay_date: '',
      id: '',
      is_pay: ''
    }
  },
  mounted: function () {
    this.getFactures()
  },
  methods: {
    getFactures () {
        this.$axios.get('/factures', {
        })
          .then(response => {
            this.factures = response.data.map((facture) => {
              return {
                ...facture,
                pay_date: new Date(facture.pay_date),
                date_created: new Date(facture.date_created)
              }
            })
          })
          .catch((erreur) => {
            console.log(erreur)
          })
      },

    postFacture() {
      this.$axios.post('/factures', {
        price: this.price,
        pay_date: this.pay_date,
      }).then((response) => {
        this.getFactures()
        this.price = response.data.msg
        this.pay_date = response.data.msg
      }).catch((erreur) => {
        console.log(erreur)
      })
    },
  }
}
</script>

<style scoped>

</style>